package com.fp.persistence.pbpm.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Query;
import javax.persistence.Table;
import javax.persistence.Transient;

import com.fp.bpmlib.BPMException;
import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TBPMRULES */
@Entity(name = "TbpmRules")
@Table(name = "TBPMRULES")
public class TbpmRules extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {
    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;

    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;

    /**
     * Clave primaria de la Entidad TbpmRules
     */
    @EmbeddedId
    private TbpmRulesKey pk;

    @Column(name = "DESCRIPTION", nullable = true)
    /**
     * Detalle de lo que hace la regla de negocio 
     */
    private String description;

    @Column(name = "PACKAGENAME", nullable = true)
    /**
     * Paquete que contiene la regla de negocio
     */
    private String packagename;

    @Column(name = "SNAPSHOT", nullable = true)
    /**
     * Imagen del paquete que contiene la regla de negocio
     */
    private String snapshot;

    @Column(name = "ACTIVE", nullable = true)
    /**
     * Y Indica que la regla esta activa
     */
    private String active;

    @Column(name = "REFRESH", nullable = true)
    /**
     * Y Indica que se asocia la regla a la base de conocimeintos antes de su ejecucion
     */
    private String refresh;

    @Column(name = "PARAMETERTYPE", nullable = true)
    /**
     * Tipo de dato de parametro a validar ates de disparar la regla
     */
    private String parametertype;

    @Column(name = "MESSAGECODE", nullable = true)
    /**
     * Codigo de plantilla de mensajes
     */
    private Integer messagecode;

    @Column(name = "CONTENT", nullable = true)
    /**
     * null
     */
    private byte[] content;;

    @Column(name = "PATH", nullable = true)
    /**
     * Ubicacion fisica de la regla o flujo
     */
    private String path;

    @Column(name = "FILETYPE", nullable = true)
    /**
     * R Rule, F Flow
     */
    private String filetype;

    /** Contructor por defecto */
    public TbpmRules() {
    }

    /**
     * Contructor de TbpmRules
     * 
     * @param pPk Clave Primaria del entity
     */
    public TbpmRules(TbpmRulesKey pPk) {
        this();
        pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * 
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TbpmRules
     */
    public static TbpmRules find(EntityManager pEntityManager, TbpmRulesKey pKey) throws Exception {
        TbpmRules obj = pEntityManager.find(TbpmRules.class, pKey);
        return obj;
    }

    /**
     * Entrega la Clave primaria de TbpmRules
     * 
     * @return El objeto que referencia a la Clave primaria de TbpmRules
     */
    public TbpmRulesKey getPk() {
        return pk;
    }

    /**
     * Fija un nuevo valor a la Clave primaria de TbpmRules
     * 
     * @param pPk El objeto que referencia a la nueva Clave primaria de TbpmRules
     */
    public void setPk(TbpmRulesKey pPk) {
        pk = pPk;
    }

    /**
     * Obtiene el valor de description
     * 
     * @return valor de description
     */
    public String getDescription() {
        return description;
    }

    /**
     * Fija el valor de description
     * 
     * @param pDescription nuevo Valor de description
     */
    public void setDescription(String pDescription) {
        description = pDescription;
    }

    /**
     * Obtiene el valor de packagename
     * 
     * @return valor de packagename
     */
    public String getPackagename() {
        return packagename;
    }

    /**
     * Fija el valor de packagename
     * 
     * @param pPackagename nuevo Valor de packagename
     */
    public void setPackagename(String pPackagename) {
        packagename = pPackagename;
    }

    /**
     * Obtiene el valor de snapshot
     * 
     * @return valor de snapshot
     */
    public String getSnapshot() {
        return snapshot;
    }

    /**
     * Fija el valor de snapshot
     * 
     * @param pSnapshot nuevo Valor de snapshot
     */
    public void setSnapshot(String pSnapshot) {
        snapshot = pSnapshot;
    }

    /**
     * Obtiene el valor de active
     * 
     * @return valor de active
     */
    public String getActive() {
        return active;
    }

    /**
     * Fija el valor de active
     * 
     * @param pActive nuevo Valor de active
     */
    public void setActive(String pActive) {
        active = pActive;
    }

    /**
     * Obtiene el valor de refresh
     * 
     * @return valor de refresh
     */
    public String getRefresh() {
        return refresh;
    }

    /**
     * Fija el valor de refresh
     * 
     * @param pRefresh nuevo Valor de refresh
     */
    public void setRefresh(String pRefresh) {
        refresh = pRefresh;
    }

    /**
     * Obtiene el valor de parametertype
     * 
     * @return valor de parametertype
     */
    public String getParametertype() {
        return parametertype;
    }

    /**
     * Fija el valor de parametertype
     * 
     * @param pParametertype nuevo Valor de parametertype
     */
    public void setParametertype(String pParametertype) {
        parametertype = pParametertype;
    }

    /**
     * Obtiene el valor de messagecode
     * 
     * @return valor de messagecode
     */
    public Integer getMessagecode() {
        return messagecode;
    }

    /**
     * Fija el valor de messagecode
     * 
     * @param pMessagecode nuevo Valor de messagecode
     */
    public void setMessagecode(Integer pMessagecode) {
        messagecode = pMessagecode;
    }

    /**
     * Obtiene el valor de content
     * 
     * @return valor de content
     */
    public byte[] getContent() {
        return content;
    }

    /**
     * Fija el valor de content
     * 
     * @param pContent nuevo Valor de content
     */
    public void setContent(byte[] pContent) {
        content = pContent;
    }

    /**
     * Obtiene el valor de path
     * 
     * @return valor de path
     */
    public String getPath() {
        return path;
    }

    /**
     * Fija el valor de path
     * 
     * @param pPath nuevo Valor de path
     */
    public void setPath(String pPath) {
        path = pPath;
    }

    /**
     * Obtiene el valor de filetype
     * 
     * @return valor de filetype
     */
    public String getFiletype() {
        return filetype;
    }

    /**
     * Fija el valor de filetype
     * 
     * @param pFiletype nuevo Valor de filetype
     */
    public void setFiletype(String pFiletype) {
        filetype = pFiletype;
    }

    @Override
    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TbpmRules)) {
            return false;
        }
        TbpmRules that = (TbpmRules) rhs;
        if (this.getPk() == null || that.getPk() == null) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**
     * Implementacion del metodo hashCode de la la entidad TbpmRules
     * 
     * @return el hashCode la instancia
     */
    @Override
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /** Implementacion toString */
    @Override
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /** Implementacion de la creacion de un bean en blanco TbpmRules */
    @Override
    public Object createInstance() {
        TbpmRules instance = new TbpmRules();
        instance.setPk(new TbpmRulesKey());
        return instance;
    }

    /**
     * Clona la entidad TbpmRules
     * 
     * @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    @Override
    public Object cloneMe() throws CloneNotSupportedException {
        TbpmRules p = (TbpmRules) this.clone();
        p.setPk((TbpmRulesKey) this.pk.cloneMe());
        return p;
    }

    // MANUALES

    /** Sentecia que entrega una lista de TbpmFieldTransactionOrigin dado un codigo de transaccion. */
    private static final String HQL_BY_SNAPSHOT = "from TbpmRules t where t.packagename = :pkg and t.snapshot = :snp and t.active = 'Y' ";

    /**
     * Metodo que entrega una lista de registros de la tabla TbpmRules dado un paquete y snapshot.
     * 
     * @param pEntityManager Referencia a la session de la base de datos.
     * @param pPKG Nombre del Paquete.
     * @param pSNP Nombre de la imagen.
     * @return List<TbpmRules>
     * @throws Exception
     */
    public static TbpmRules find(EntityManager pEntityManager, String pPKG, String pSNP) throws Exception {
        Query qry = pEntityManager.createQuery(TbpmRules.HQL_BY_SNAPSHOT);
        qry.setParameter("pkg", pPKG);
        qry.setParameter("snp", pSNP);
        List<TbpmRules> l = qry.getResultList();
        // TbpmRules r = (TbpmRules) qry.getSingleResult();
        // if (r == null) {
        if (l.isEmpty()) {
            throw new BPMException("BPM-0003", "NO ESTA DISPONIBLE {0} {1}", pPKG, pSNP);
        }
        return l.get(0);
    }

    /**
     * Metodo que entrega una lista de registros de la tabla TbpmRules dado un paquete y snapshot.
     * 
     * @param pEntityManager Referencia a la session de la base de datos.
     * @param pPKG Nombre del Paquete.
     * @param pSNP Nombre de la imagen.
     * @return List<TbpmRules>
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
    public static List<TbpmRules> findRules(EntityManager pEntityManager, String pPKG, String pSNP) throws Exception {
        Query qry = pEntityManager.createQuery(TbpmRules.HQL_BY_SNAPSHOT);
        qry.setParameter("pkg", pPKG);
        qry.setParameter("snp", pSNP);
        List<TbpmRules> l = qry.getResultList();
        // TbpmRules r = (TbpmRules) qry.getSingleResult();
        // if (r == null) {
        if (l.isEmpty()) {
            throw new BPMException("BPM-0003", "NO ESTA DISPONIBLE {0} {1}", pPKG, pSNP);
        }
        return l;

    }

    /** Sentecia que entrega una lista de TbpmFieldTransactionOrigin dado un codigo de transaccion. */
    private static final String HQL_TOTAL = "from TbpmRules t where t.active = 'Y' ";

    /**
     * Metodo que entrega una lista de registros de la tabla TbpmRules dado un paquete y snapshot.
     * 
     * @param pEntityManager Referencia a la session de la base de datos.
     * @return List<TbpmRules>
     * @throws Exception
     */
    @SuppressWarnings("unchecked")
    public static List<TbpmRules> findRules(EntityManager pEntityManager) throws Exception {
        Query qry = pEntityManager.createQuery(TbpmRules.HQL_TOTAL);
        List<TbpmRules> l = qry.getResultList();
        if (l.isEmpty()) {
            throw new BPMException("BPM-0003", "NO ESTA DISPONIBLE");
        }
        return l;
    }
    
}
